> ## Documentation Index
> Fetch the complete documentation index at: https://algolia.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Dynamic widgets

> Renders matching refinement widgets in the facet order returned by Algolia.

export const DynamicFacets = ({current}) => <div>
    <p>
      This widget displays matching refinement widgets in the order provided by{" "}
      <a className="link" href="/doc/api-reference/api-parameters/renderingContent#param-facet-ordering">
        <code>renderingContent.facetOrdering</code>
      </a>{" "}
      in the search response. 
    </p>

    <p>
      Configure the order with{" "}
      <a className="link" href={`/doc/guides/building-search-ui/ui-and-ux-patterns/facet-display/${current}`}>
        facet display
      </a>
      , override it with{" "}
      <a className="link" href="/doc/guides/managing-results/rules/rules-overview">
        Algolia Rules
      </a>
      , or generate it automatically with{" "}
      <a className="link" href="/doc/guides/algolia-ai/dynamic-facets">
        Dynamic Facets
      </a>
      . Dynamic Facets orders facets and facet values based on recent search
      data.
    </p>
  </div>;

export const FlavorSwitcher = ({current, baseHref = "", options = [], label = "InstantSearch framework"}) => {
  if (options.length === 0) {
    return <div className="not-prose" role="alert" style={{
      margin: "0.25rem 0 1.5rem",
      padding: "0.75rem",
      border: "1px solid #f59e0b",
      borderRadius: "0.625rem",
      color: "inherit",
      fontSize: "0.875rem"
    }}>
        FlavorSwitcher requires at least one option.
      </div>;
  }
  const selected = options.find(option => option.value === current) ?? options[0];
  return <div className="not-prose mint-flavor-switcher">
      <style>{`
        .mint-flavor-switcher {
          --mfs-bg: #ffffff;
          --mfs-bg-hover: #f4f4f5;
          --mfs-bg-current: #eef2ff;
          --mfs-border: #d4d4d8;
          --mfs-fg: #18181b;
          --mfs-muted: #71717a;
          --mfs-accent: #4f46e5;
          position: relative;
          width: min(100%, 19rem);
          margin: 0.25rem 0 1.5rem;
          color: var(--mfs-fg);
          font-size: 0.875rem;
          line-height: 1.25rem;
        }

        .dark .mint-flavor-switcher {
          --mfs-bg: #18181b;
          --mfs-bg-hover: #27272a;
          --mfs-bg-current: #272747;
          --mfs-border: #3f3f46;
          --mfs-fg: #fafafa;
          --mfs-muted: #a1a1aa;
          --mfs-accent: #a5b4fc;
        }

        .mint-flavor-switcher details {
          position: relative;
        }

        .mint-flavor-switcher summary {
          display: flex;
          min-height: 2.75rem;
          box-sizing: border-box;
          align-items: center;
          justify-content: space-between;
          gap: 0.75rem;
          padding: 0.625rem 0.75rem;
          border: 1px solid var(--mfs-border);
          border-radius: 0.625rem;
          background: var(--mfs-bg);
          color: var(--mfs-fg);
          cursor: pointer;
          font-weight: 600;
          list-style: none;
          transition: border-color 150ms ease, box-shadow 150ms ease;
        }

        .mint-flavor-switcher summary::-webkit-details-marker {
          display: none;
        }

        .mint-flavor-switcher summary:hover {
          border-color: var(--mfs-accent);
        }

        .mint-flavor-switcher summary:focus-visible {
          outline: 2px solid var(--mfs-accent);
          outline-offset: 2px;
        }

        .mint-flavor-switcher__label {
          overflow: hidden;
          text-overflow: ellipsis;
          white-space: nowrap;
        }

        .mint-flavor-switcher__chevron {
          flex: none;
          transition: transform 150ms ease;
        }

        .mint-flavor-switcher details[open] .mint-flavor-switcher__chevron {
          transform: rotate(180deg);
        }

        .mint-flavor-switcher__menu {
          position: absolute;
          z-index: 50;
          top: calc(100% + 0.375rem);
          left: 0;
          width: 100%;
          box-sizing: border-box;
          margin: 0;
          padding: 0.375rem;
          border: 1px solid var(--mfs-border);
          border-radius: 0.625rem;
          background: var(--mfs-bg);
          box-shadow: 0 12px 30px rgb(0 0 0 / 16%);
          list-style: none;
        }

        .mint-flavor-switcher__menu li {
          margin: 0;
          padding: 0;
        }

        .mint-flavor-switcher__option {
          display: grid;
          gap: 0.125rem;
          padding: 0.625rem 0.75rem;
          border-radius: 0.4rem;
          color: var(--mfs-fg);
          text-decoration: none;
        }

        .mint-flavor-switcher__option:hover {
          background: var(--mfs-bg-hover);
        }

        .mint-flavor-switcher__option:focus-visible {
          outline: 2px solid var(--mfs-accent);
          outline-offset: -2px;
        }

        .mint-flavor-switcher__option[aria-current="page"] {
          background: var(--mfs-bg-current);
          color: var(--mfs-accent);
        }

        .mint-flavor-switcher__name {
          font-weight: 600;
        }

        .mint-flavor-switcher__description {
          color: var(--mfs-muted);
          font-size: 0.8125rem;
        }

        @media (prefers-reduced-motion: reduce) {
          .mint-flavor-switcher summary,
          .mint-flavor-switcher__chevron {
            transition: none;
          }
        }
      `}</style>

      <details>
        <summary aria-label={`${label}: ${selected.label}`}>
          <span className="mint-flavor-switcher__label">{selected.label}</span>
          <svg className="mint-flavor-switcher__chevron" width="18" height="18" viewBox="0 0 24 24" fill="none" stroke="currentColor" strokeWidth="2" strokeLinecap="round" strokeLinejoin="round" aria-hidden="true">
            <path d="m6 9 6 6 6-6" />
          </svg>
        </summary>

        <ul className="mint-flavor-switcher__menu" aria-label={label}>
          {options.map(option => {
    const isCurrent = option.value === selected.value;
    const href = option.href ?? `${baseHref.replace(/\/$/, "")}/${encodeURIComponent(option.value)}`;
    return <li key={option.value}>
                <a className="mint-flavor-switcher__option" href={href} aria-current={isCurrent ? "page" : undefined}>
                  <span className="mint-flavor-switcher__name">
                    {option.label}
                  </span>
                  {option.description ? <span className="mint-flavor-switcher__description">
                      {option.description}
                    </span> : null}
                </a>
              </li>;
  })}
        </ul>
      </details>
    </div>;
};

<div className="mint-flavor-switcher-slot not-prose">
  <FlavorSwitcher
    current="vue"
    baseHref="/doc/api-reference/widgets/dynamic-widgets"
    options={[
{ value: "js", label: "JavaScript", description: "InstantSearch.js" },
{ value: "react", label: "React", description: "React InstantSearch" },
{ value: "vue", label: "Vue", description: "Vue InstantSearch" },
{ value: "ios", label: "iOS", description: "InstantSearch iOS" },
{ value: "android", label: "Android", description: "InstantSearch Android" },
]}
  />
</div>

```vue Signature theme={"system"}
<ais-dynamic-widgets
  // Optional parameters
  transform-items="function"
  facets="['*']|[]"
  max-values-per-facet="number"
>
  children
</ais-dynamic-widgets>
```

## Import

<Tabs>
  <Tab title="Component">
    To ensure optimal bundle sizes,
    see [Optimize build size](/doc/guides/building-search-ui/going-further/improve-performance/vue#optimize-build-size).

    ```js Vue icon=code theme={"system"}
    import { AisDynamicWidgets } from "vue-instantsearch";
    // Use "vue-instantsearch/vue3/es" for Vue 3

    export default {
      components: {
        AisDynamicWidgets,
      },
      // ...
    };
    ```
  </Tab>

  <Tab title="Plugin">
    This imports all widgets, even the ones you don't use.
    For more information, see [Get started with Vue InstantSearch](/doc/guides/building-search-ui/getting-started/vue).

    ```js JavaScript icon="code" theme={"system"}
    import Vue from "vue";
    import InstantSearch from "vue-instantsearch";
    // Use "vue-instantsearch/vue3/es" for Vue 3

    Vue.use(InstantSearch);
    ```
  </Tab>
</Tabs>

<Card title="See this widget in action" icon="monitor-play" href="https://instantsearchjs.netlify.app/stories/vue/?selectedKind=ais-dynamic-widgets&selectedStory=simple%20usage" horizontal>
  Preview this widget and its behavior.
</Card>

## About this widget

<DynamicFacets current="vue" />

### Requirements

Declare each facet attribute in [`attributesForFaceting`](/doc/api-reference/api-parameters/attributesForFaceting).

Configure the facet order in the [Algolia dashboard](/doc/guides/managing-results/refine-results/faceting/how-to/declaring-attributes-for-faceting-with-dashboard) or
with [`renderingContent.facetOrdering`](/doc/api-reference/api-parameters/renderingContent#param-facet-ordering).

By default, `<ais-dynamic-widgets>` requests all facets and up to 20 values per facet.
These defaults help avoid another request after matching widgets mount.

Override the defaults with [`facets`](#param-facets) and [`max-values-per-facet`](#param-max-values-per-facet).

<Note>
  `<ais-dynamic-widgets>` requires Vue InstantSearch 3.8.0 or later.
</Note>

## Examples

<CodeGroup>
  ```vue Default theme={"system"}
  <ais-dynamic-widgets>
    <ais-refinement-list attribute="brand" />
    <ais-panel>
      <ais-menu attribute="categories" />
    </ais-panel>
    <ais-hierarchical-menu :attributes="['categories']" />
  </ais-dynamic-widgets>
  ```

  ```vue Multiple requests theme={"system"}
  <ais-dynamic-widgets :facets="[]">
    <ais-refinement-list attribute="brand" />
    <ais-panel>
      <ais-menu attribute="categories" />
    </ais-panel>
    <ais-hierarchical-menu :attributes="['categories']" />
  </ais-dynamic-widgets>
  ```
</CodeGroup>

## Options

<ParamField body="children" type="Widget[]" required>
  The refinement widgets to render in the order specified by [`renderingContent.facetOrdering`](/doc/api-reference/api-parameters/renderingContent#param-facet-ordering).

  Each top-level child must resolve to one unique facet attribute.
  Define an `attribute` prop for single-attribute widgets or an `attributes` prop for hierarchical widgets.

  <CodeGroup>
    ```vue Widget theme={"system"}
    <ais-dynamic-widgets>
      <ais-refinement-list attribute="brand" />
    </ais-dynamic-widgets>
    ```

    ```vue Hierarchical menu theme={"system"}
    <ais-dynamic-widgets>
      <ais-hierarchical-menu :attributes="['categories']" />
    </ais-dynamic-widgets>
    ```

    ```vue Panel theme={"system"}
    <ais-dynamic-widgets>
      <ais-panel>
        <ais-menu attribute="categories" />
      </ais-panel>
    </ais-dynamic-widgets>
    ```

    ```vue Custom widget theme={"system"}
    <ais-dynamic-widgets>
      <my-custom-widget attribute="brand" />
    </ais-dynamic-widgets>
    ```
  </CodeGroup>
</ParamField>

<ParamField body="transform-items" type="function">
  Transforms the facet attributes before rendering.

  The second argument contains the search results, which you can use to derive a different attribute list.

  The function receives the ordered facet attributes from [`renderingContent.facetOrdering.facets.order`](/doc/api-reference/api-parameters/renderingContent#param-facets-order) and returns an array.

  ```vue Vue icon=code theme={"system"}
  <template>
    <ais-dynamic-widgets
      :transform-items="transformItems"
    >
      <!-- ... -->
    </ais-dynamic-widgets>
  </template>

  <script>
  export default {
    methods: {
      transformItems(items, { results }) {
        return items;
      }
    }
  }
  </script>
  ```
</ParamField>

<ParamField body="facets" type="['*']|[]" default="['*']">
  The facets to apply before dynamic widgets get mounted.
  Setting the value to `['*']` will request all facets and avoid an additional network request once the widgets are added.

  <CodeGroup>
    ```vue Default theme={"system"}
    <ais-dynamic-widgets
      :facets="['*']"
    />
    ```

    ```vue No facets theme={"system"}
    <ais-dynamic-widgets
      :facets="[]"
    />
    ```
  </CodeGroup>
</ParamField>

<ParamField body="max-values-per-facet" type="number" default={20}>
  The maximum number of values to request for each facet.

  Set this value to at least the highest `limit` or `show-more-limit` used by a dynamic widget.
  This helps avoid an additional request after the widget mounts.

  Set `max-values-per-facet` to at least the largest number of pinned values configured for any facet.
  Otherwise, some pinned facet values might not appear.

  ```vue Vue icon=code theme={"system"}
  <ais-dynamic-widgets
    // ...
    :max-values-per-facet="500"
  />
  ```
</ParamField>


> ## Documentation Index
> Fetch the complete documentation index at: https://algolia.com/llms.txt
> Use this file to discover all available pages before exploring further.

# ais-dynamic-widgets

> Renders matching refinement widgets in the facet order returned by Algolia.

export const DynamicFacets = ({current}) => <div>
    <p>
      This widget displays matching refinement widgets in the order provided by{" "}
      <a className="link" href="/doc/api-reference/api-parameters/renderingContent#param-facet-ordering">
        <code>renderingContent.facetOrdering</code>
      </a>{" "}
      in the search response. 
    </p>

    <p>
      Configure the order with{" "}
      <a className="link" href={`/doc/guides/building-search-ui/ui-and-ux-patterns/facet-display/${current}`}>
        facet display
      </a>
      , override it with{" "}
      <a className="link" href="/doc/guides/managing-results/rules/rules-overview">
        Algolia Rules
      </a>
      , or generate it automatically with{" "}
      <a className="link" href="/doc/guides/algolia-ai/dynamic-facets">
        Dynamic Facets
      </a>
      . Dynamic Facets orders facets and facet values based on recent search
      data.
    </p>
  </div>;

export const FlavorSwitcher = ({current, baseHref = "", options = [], label = "InstantSearch framework"}) => {
  if (options.length === 0) {
    return <div className="not-prose" role="alert" style={{
      margin: "0.25rem 0 1.5rem",
      padding: "0.75rem",
      border: "1px solid #f59e0b",
      borderRadius: "0.625rem",
      color: "inherit",
      fontSize: "0.875rem"
    }}>
        FlavorSwitcher requires at least one option.
      </div>;
  }
  const selected = options.find(option => option.value === current) ?? options[0];
  return <div className="not-prose mint-flavor-switcher">
      <style>{`
        .mint-flavor-switcher {
          --mfs-bg: #ffffff;
          --mfs-bg-hover: #f4f4f5;
          --mfs-bg-current: #eef2ff;
          --mfs-border: #d4d4d8;
          --mfs-fg: #18181b;
          --mfs-muted: #71717a;
          --mfs-accent: #4f46e5;
          position: relative;
          width: min(100%, 19rem);
          margin: 0.25rem 0 1.5rem;
          color: var(--mfs-fg);
          font-size: 0.875rem;
          line-height: 1.25rem;
        }

        .dark .mint-flavor-switcher {
          --mfs-bg: #18181b;
          --mfs-bg-hover: #27272a;
          --mfs-bg-current: #272747;
          --mfs-border: #3f3f46;
          --mfs-fg: #fafafa;
          --mfs-muted: #a1a1aa;
          --mfs-accent: #a5b4fc;
        }

        .mint-flavor-switcher details {
          position: relative;
        }

        .mint-flavor-switcher summary {
          display: flex;
          min-height: 2.75rem;
          box-sizing: border-box;
          align-items: center;
          justify-content: space-between;
          gap: 0.75rem;
          padding: 0.625rem 0.75rem;
          border: 1px solid var(--mfs-border);
          border-radius: 0.625rem;
          background: var(--mfs-bg);
          color: var(--mfs-fg);
          cursor: pointer;
          font-weight: 600;
          list-style: none;
          transition: border-color 150ms ease, box-shadow 150ms ease;
        }

        .mint-flavor-switcher summary::-webkit-details-marker {
          display: none;
        }

        .mint-flavor-switcher summary:hover {
          border-color: var(--mfs-accent);
        }

        .mint-flavor-switcher summary:focus-visible {
          outline: 2px solid var(--mfs-accent);
          outline-offset: 2px;
        }

        .mint-flavor-switcher__label {
          overflow: hidden;
          text-overflow: ellipsis;
          white-space: nowrap;
        }

        .mint-flavor-switcher__chevron {
          flex: none;
          transition: transform 150ms ease;
        }

        .mint-flavor-switcher details[open] .mint-flavor-switcher__chevron {
          transform: rotate(180deg);
        }

        .mint-flavor-switcher__menu {
          position: absolute;
          z-index: 50;
          top: calc(100% + 0.375rem);
          left: 0;
          width: 100%;
          box-sizing: border-box;
          margin: 0;
          padding: 0.375rem;
          border: 1px solid var(--mfs-border);
          border-radius: 0.625rem;
          background: var(--mfs-bg);
          box-shadow: 0 12px 30px rgb(0 0 0 / 16%);
          list-style: none;
        }

        .mint-flavor-switcher__menu li {
          margin: 0;
          padding: 0;
        }

        .mint-flavor-switcher__option {
          display: grid;
          gap: 0.125rem;
          padding: 0.625rem 0.75rem;
          border-radius: 0.4rem;
          color: var(--mfs-fg);
          text-decoration: none;
        }

        .mint-flavor-switcher__option:hover {
          background: var(--mfs-bg-hover);
        }

        .mint-flavor-switcher__option:focus-visible {
          outline: 2px solid var(--mfs-accent);
          outline-offset: -2px;
        }

        .mint-flavor-switcher__option[aria-current="page"] {
          background: var(--mfs-bg-current);
          color: var(--mfs-accent);
        }

        .mint-flavor-switcher__name {
          font-weight: 600;
        }

        .mint-flavor-switcher__description {
          color: var(--mfs-muted);
          font-size: 0.8125rem;
        }

        @media (prefers-reduced-motion: reduce) {
          .mint-flavor-switcher summary,
          .mint-flavor-switcher__chevron {
            transition: none;
          }
        }
      `}</style>

      <details>
        <summary aria-label={`${label}: ${selected.label}`}>
          <span className="mint-flavor-switcher__label">{selected.label}</span>
          <svg className="mint-flavor-switcher__chevron" width="18" height="18" viewBox="0 0 24 24" fill="none" stroke="currentColor" strokeWidth="2" strokeLinecap="round" strokeLinejoin="round" aria-hidden="true">
            <path d="m6 9 6 6 6-6" />
          </svg>
        </summary>

        <ul className="mint-flavor-switcher__menu" aria-label={label}>
          {options.map(option => {
    const isCurrent = option.value === selected.value;
    const href = option.href ?? `${baseHref.replace(/\/$/, "")}/${encodeURIComponent(option.value)}`;
    return <li key={option.value}>
                <a className="mint-flavor-switcher__option" href={href} aria-current={isCurrent ? "page" : undefined}>
                  <span className="mint-flavor-switcher__name">
                    {option.label}
                  </span>
                  {option.description ? <span className="mint-flavor-switcher__description">
                      {option.description}
                    </span> : null}
                </a>
              </li>;
  })}
        </ul>
      </details>
    </div>;
};

<div className="mint-flavor-switcher-slot not-prose">
  <FlavorSwitcher
    current="react"
    baseHref="/doc/api-reference/widgets/dynamic-widgets"
    options={[
{ value: "js", label: "JavaScript", description: "InstantSearch.js" },
{ value: "react", label: "React", description: "React InstantSearch" },
{ value: "vue", label: "Vue", description: "Vue InstantSearch" },
{ value: "ios", label: "iOS", description: "InstantSearch iOS" },
{ value: "android", label: "Android", description: "InstantSearch Android" },
]}
  />
</div>

<Note>
  This is the **React InstantSearch v7** documentation.
  If you're upgrading from v6, see the [upgrade guide](/doc/guides/building-search-ui/upgrade-guides/react/#migrate-from-react-instantsearch-v6-to-react-instantsearch-v7).
  If you were using React InstantSearch Hooks,
  this v7 documentation applies—just check for [necessary changes](/doc/guides/building-search-ui/upgrade-guides/react/#migrate-from-react-instantsearch-hooks-to-react-instantsearch-v7).
  To continue using v6, you can find the [archived documentation](https://algolia.com/old-docs/deprecated/instantsearch/react/v6/api-reference/instantsearch/).
</Note>

```tsx Signature theme={"system"}
<DynamicWidgets
  // Optional parameters
  transformItems={function}
  fallbackComponent={ReactNode}
  facets={['*'] | []}
  maxValuesPerFacet={number}
>
  {children}
</DynamicWidgets>
```

## Import

```jsx JavaScript icon=code theme={"system"}
import { DynamicWidgets } from "react-instantsearch";
```

<Card title="See this widget in action" icon="monitor-play" href="https://instantsearchjs.netlify.app/stories/?path=/story/basics-dynamicwidgets--default" horizontal>
  Preview this widget and its behavior.
</Card>

## About this widget

<DynamicFacets current="react" />

By default, `<DynamicWidgets>` requests all facets and up to 20 values per facet.
These defaults help avoid another request after the matching widgets mount.

Override the defaults with [`facets`](#param-facets) and [`maxValuesPerFacet`](#param-max-values-per-facet).

During server-side rendering, InstantSearch performs two render passes so that the UI includes the correct refinements.

<Tip>You can also create your own UI with [`useDynamicWidgets`](#hook).</Tip>

### Requirements

Declare each facet attribute in [`attributesForFaceting`](/doc/api-reference/api-parameters/attributesForFaceting).

Configure the facet order in the [Algolia dashboard](/doc/guides/managing-results/refine-results/faceting/how-to/declaring-attributes-for-faceting-with-dashboard) or
with [`renderingContent.facetOrdering`](/doc/api-reference/api-parameters/renderingContent#param-facet-ordering).

## Example

```jsx JavaScript icon=code theme={"system"}
import { InstantSearch, DynamicWidgets } from "react-instantsearch";

function App(props) {
  return (
    <InstantSearch {...props}>
      <DynamicWidgets>
        <HierarchicalMenu
          attributes={["hierarchical.lvl0", "hierarchical.lvl1"]}
        />
        <RefinementList attribute="brand" />
      </DynamicWidgets>
    </InstantSearch>
  );
}
```

## Props

<ParamField body="children" type="React.ReactNode">
  The refinement widgets to render in the order specified by [`renderingContent.facetOrdering`](/doc/api-reference/api-parameters/renderingContent#param-facet-ordering).

  Each child must define an `attribute` or `attributes` prop.

  <CodeGroup>
    ```jsx Direct children theme={"system"}
    <DynamicWidgets>
      <HierarchicalMenu attributes={["hierarchical.lvl0", "hierarchical.lvl1"]} />
      <RefinementList attribute="brand" />
    </DynamicWidgets>;
    ```

    ```jsx Children in panel theme={"system"}
    <DynamicWidgets>
      <Panel header="Categories">
        <HierarchicalMenu attributes={["hierarchical.lvl0", "hierarchical.lvl1"]} />
      </Panel>
      <Panel header="Brands">
        <RefinementList attribute="brand" />
      </Panel>
    </DynamicWidgets>;
    ```
  </CodeGroup>
</ParamField>

<ParamField body="fallbackComponent" type="React.ReactNode">
  A component to render for each ordered facet attribute that doesn't match a child.

  The component receives the unmatched facet attribute in its `attribute` prop.

  <CodeGroup>
    ```jsx App.js theme={"system"}
    <DynamicWidgets fallbackComponent={RefinementList} />;
    ```

    ```jsx RefinementList.js theme={"system"}
    export function RefinementList(props) {
      const { items, refine } = useRefinementList(props);

      return <>{/* Your JSX */}</>;
    }
    ```
  </CodeGroup>
</ParamField>

<ParamField body="transformItems" type="(items: string[], metadata: { results: SearchResults }) => string[]">
  Transforms the facet attributes before rendering.

  The second argument contains the search results, which you can use to derive a different attribute list.

  <CodeGroup>
    ```jsx JavaScript theme={"system"}
    const transformItems = (items, { results }) => {
      return results.userData.customOrdering;
    };

    function Search() {
      return <DynamicWidgets transformItems={transformItems} />;
    }
    ```

    ```tsx TypeScript theme={"system"}
    import type { DynamicWidgetsProps } from "react-instantsearch";

    const transformItems: DynamicWidgetsProps["transformItems"] = (
      items,
      { results },
    ) => {
      return results.userData.customOrdering;
    };

    function Search() {
      return <DynamicWidgets transformItems={transformItems} />;
    }
    ```
  </CodeGroup>
</ParamField>

<ParamField body="facets" type="['*']|[]" default="['*']">
  The facets to apply before dynamic widgets get mounted.

  Setting the value to `['*']` will request all facets and avoid an additional network request once the widgets are rendered.

  <CodeGroup>
    ```jsx All facets theme={"system"}
    <DynamicWidgets facets={["*"]} />;
    ```

    ```jsx No facets theme={"system"}
    <DynamicWidgets facets={[]} />;
    ```
  </CodeGroup>
</ParamField>

<ParamField body="maxValuesPerFacet" type="number" default={20}>
  The maximum number of values to request for each facet.

  Set this value to at least the highest `limit` or `showMoreLimit` used by a dynamic widget.
  This helps avoid an additional request after the widget mounts.

  Set `maxValuesPerFacet` to at least the largest number of pinned values configured for any facet.
  Otherwise, some pinned values might not appear.

  ```jsx JavaScript icon=code theme={"system"}
  <DynamicWidgets maxValuesPerFacet={500} />;
  ```
</ParamField>

## Hook

Use the `useDynamicWidgets` Hook to build a custom dynamic widgets UI.

The Hook must run inside [`<InstantSearch>`](/doc/api-reference/widgets/instantsearch/react).

React InstantSearch lets you create your own UI for the `<DynamicWidgets>` widget with `useDynamicWidgets`.
Hooks provide APIs to access the widget state and interact with InstantSearch.

### Usage

First, create your React component:

```jsx JavaScript icon=code theme={"system"}
import { useDynamicWidgets } from "react-instantsearch";

function CustomDynamicWidgets(props) {
  const { attributesToRender } = useDynamicWidgets(props);

  return <>{/* Your JSX */}</>;
}
```

Then, render the widget:

```jsx JavaScript icon=code theme={"system"}
<CustomDynamicWidgets {...props} />;
```

### Parameters

Hooks accept parameters. You can either pass them manually or forward props from a custom component.

<Note>
  When passing functions to Hooks, ensure stable references to prevent unnecessary re-renders.
  Use [`useCallback()`](https://reactjs.org/docs/hooks-reference.html#usecallback) for memoization.
  Arrays and objects are automatically memoized.
</Note>

<ParamField body="transformItems" type="function">
  A function to transform the attributes to render,
  or using a different source to determine the attributes to render.

  <CodeGroup>
    ```jsx JavaScript theme={"system"}
    const transformItems = (items, { results }) => {
      return results.userData.customOrdering;
    };

    function DynamicWidgets() {
      const dynamicWidgetsApi = useDynamicWidgets({ transformItems });

      return <>{/* Your JSX */}</>;
    }
    ```

    ```tsx TypeScript theme={"system"}
    import type { UseDynamicWidgetsProps } from "react-instantsearch";

    const transformItems: UseDynamicWidgetsProps["transformItems"] = (
      items,
      { results },
    ) => {
      return results.userData.customOrdering;
    };

    function DynamicWidgets() {
      const dynamicWidgetsApi = useDynamicWidgets({ transformItems });

      return <>{/* Your JSX */}</>;
    }
    ```
  </CodeGroup>
</ParamField>

<ParamField body="facets" type="['*']|[]" default="['*']">
  The facets to apply before dynamic widgets get mounted.
  Setting the value to `['*']` will request all facets and avoid an additional network request once the widgets are added.

  <CodeGroup>
    ```jsx Default theme={"system"}
    function DynamicWidgets() {
      const dynamicWidgetsApi = useDynamicWidgets({
        facets: ["*"],
      });

      return <>{/* Your JSX */}</>;
    }
    ```

    ```jsx No facets theme={"system"}
    function DynamicWidgets() {
      const dynamicWidgetsApi = useDynamicWidgets({
        facets: [],
      });

      return <>{/* Your JSX */}</>;
    }
    ```
  </CodeGroup>
</ParamField>

<ParamField body="maxValuesPerFacet" type="number" default={20}>
  The default number of facet values to request.
  It's recommended to have this value at least as high as the highest `limit` and `showMoreLimit` of dynamic widgets,
  as this prevents a second network request once that widget mounts.

  To avoid pinned items not showing in the result,
  make sure you choose a `maxValuesPerFacet` at least as high as all the most pinned items you have.

  ```jsx JavaScript icon=code theme={"system"}
  function DynamicWidgets() {
    const dynamicWidgetsApi = useDynamicWidgets({
      maxValuesPerFacet: 500,
    });

    return <>{/* Your JSX */}</>;
  }
  ```
</ParamField>

### APIs

Hooks return APIs, such as state and functions. You can use them to build your UI and interact with React InstantSearch.

<ParamField body="attributesToRender" type="string[]">
  The ordered facet attributes to render,
  derived from \[]`renderingContent.facetOrdering.facets.order`]\(/doc/api-reference/api-parameters/renderingContent#param-facets-order).

  ```jsx JavaScript icon=code theme={"system"}
  function DynamicWidgets(props) {
    const { attributesToRender } = useDynamicWidgets(props);

    return attributesToRender.map((attribute) => (
      <RefinementList key={attribute} attribute={attribute} />
    ));
  }
  ```
</ParamField>

### Example

<CodeGroup>
  ```jsx JavaScript theme={"system"}
  import { RefinementList, useDynamicWidgets } from "react-instantsearch";

  function CustomDynamicWidgets(props) {
    const { attributesToRender } = useDynamicWidgets(props);

    return attributesToRender.map((attribute) => (
      <RefinementList key={attribute} attribute={attribute} />
    ));
  }
  ```

  ```tsx TypeScript theme={"system"}
  import {
    RefinementList,
    useDynamicWidgets,
    UseDynamicWidgetsProps,
  } from "react-instantsearch";

  function CustomDynamicWidgets(props: UseDynamicWidgetsProps) {
    const { attributesToRender } = useDynamicWidgets(props);

    return attributesToRender.map((attribute) => (
      <RefinementList key={attribute} attribute={attribute} />
    ));
  }
  ```
</CodeGroup>
